Legrand / Raritan / Server Technology Xerus™ JSON-RPC API

Loading...
Searching...
No Matches
DisplayControl.idl
1/* SPDX-License-Identifier: BSD-3-Clause */
2/*
3 * Copyright 2014 Raritan Inc. All rights reserved.
4 */
5
6#include <UserEvent.idl>
7
8/** Front panel display interface */
9module display {
10 /**
11 * Interface to control the device's front panel display
12 */
13 interface DisplayControl {
14 /**
15 * Error codes
16 */
17 constant int SUCCESS = 0; ///< No error
18 constant int ERR_INVALID_VALUE = 1; ///< Invalid argument
19
20 /** Collected display meta information */
21 structure Info {
22 int fwAppVersion; ///< Firmware application version; 0 if unavailable
23 int fwBootVersion; ///< Firmware bootloader version; 0 if unavailable
24 int orientation; ///< Display orientation
25 int width; ///< Display width
26 int height; ///< Display height
27 boolean versionAvailable; ///< \c true if version information is available
28 };
29
30 /**
31 * Representation of a possible default view
32 */
33 structure DefaultViewItem {
34 string id; ///< View ID
35 string description; ///< Textual description
36 };
37
38 structure Settings {
39 string defaultView; ///< Default view ID (might be an empty string
40 ///< if the device doesn't allow default view configuration)
41 int backlightTimeout; ///< Backlight timeout in seconds, or 0 for no timeout
42 };
43
44 /** Event: Settings were changed */
45 valueobject SettingsChangedEvent extends event.UserEvent {
46 Settings newSettings; ///< New settings
47 };
48
49 /**
50 * Get available default views. This returns all views that can be
51 * used as default views on the device display.
52 *
53 * @return Possible default views, or empty list if the default view
54 * can not be configured for the device's display
55 */
56 vector<DefaultViewItem> getAvailableDefaultViews();
57
58 /**
59 * Get the current settings
60 *
61 * @return settings
62 */
63 Settings getSettings();
64
65 /**
66 * Update the settings
67 *
68 * @param settings Settings to be applied
69 *
70 * @return 0 on success
71 * @return 1 on invalid value
72 */
73 int setSettings(in Settings settings);
74
75 /**
76 * Retrieve display's meta information.
77 *
78 * @return Display information
79 */
80 Info getInfo();
81
82 /**
83 * Show smiley on display
84 *
85 * @param on \c true to turn on smiley
86 * @param happy \c true to show happy smiley,\c false to show sad smiley
87 * @param msg String for message
88 */
89 void showSmiley(in boolean on, in boolean happy, in string msg);
90 };
91}
display::DisplayControl
Interface to control the device's front panel display.
Definition DisplayControl.idl:13
display::DisplayControl::getInfo
Info getInfo()
Retrieve display's meta information.
display::DisplayControl::setSettings
int setSettings(in Settings settings)
Update the settings.
display::DisplayControl::showSmiley
void showSmiley(in boolean on, in boolean happy, in string msg)
Show smiley on display.
display::DisplayControl::getAvailableDefaultViews
vector< DefaultViewItem > getAvailableDefaultViews()
Get available default views.
display::DisplayControl::getSettings
Settings getSettings()
Get the current settings.
display
Front panel display interface.
Definition DisplayControl.idl:9
display::DisplayControl::DefaultViewItem
Representation of a possible default view.
Definition DisplayControl.idl:33
display::DisplayControl::DefaultViewItem::id
string id
View ID.
Definition DisplayControl.idl:34
display::DisplayControl::DefaultViewItem::description
string description
Textual description.
Definition DisplayControl.idl:35
display::DisplayControl::Info
Collected display meta information.
Definition DisplayControl.idl:21
display::DisplayControl::Info::width
int width
Display width.
Definition DisplayControl.idl:25
display::DisplayControl::Info::height
int height
Display height.
Definition DisplayControl.idl:26
display::DisplayControl::Info::fwBootVersion
int fwBootVersion
Firmware bootloader version; 0 if unavailable.
Definition DisplayControl.idl:23
display::DisplayControl::Info::versionAvailable
boolean versionAvailable
true if version information is available
Definition DisplayControl.idl:27
display::DisplayControl::Info::fwAppVersion
int fwAppVersion
Firmware application version; 0 if unavailable.
Definition DisplayControl.idl:22
display::DisplayControl::Info::orientation
int orientation
Display orientation.
Definition DisplayControl.idl:24
display::DisplayControl::SettingsChangedEvent
Event: Settings were changed.
Definition DisplayControl.idl:45
display::DisplayControl::SettingsChangedEvent::newSettings
Settings newSettings
New settings.
Definition DisplayControl.idl:46
display::DisplayControl::Settings
Definition DisplayControl.idl:38
display::DisplayControl::Settings::backlightTimeout
int backlightTimeout
Backlight timeout in seconds, or 0 for no timeout.
Definition DisplayControl.idl:41
display::DisplayControl::Settings::defaultView
string defaultView
Default view ID (might be an empty string if the device doesn't allow default view configuration)
Definition DisplayControl.idl:39